               ; Car Booster v2
               ; Betriebsprogramm
               ; (c) Tassilo Heeg 1999
               ; Grafik-Modul fr Hochauflsende Grafik 184*220
               ; dies ermglicht 2 Speicherseiten...
 
               ; Funktionen:
               ; GRAPH_Init         Grafik initalisieren, LoRes, CLS
               ; GRAPH_SetHiRes     Hohe Auflsung einstellen (184*256)
               ; GRAPH_SetColor     Schreibt Farbe Nr. A in RAMDAC (RGB=HLD)
               ; GRAPH_CLS          Aktuelle Bildseite lschen mit Farbe 0
               ; GRAPH_CLS_Color    Aktuelle Bildseite lschen mit Farbe A
               ; GRAPH_SetPixel     Pixel x=E y=D in Farbe C malen
               ; GRAPH_FastSetPixel Pixel x=E y=D in Farbe C malen, mit Schnee
               ; GRAPH_WriteCharTS  8x8 Zeichen A an Pos. x=E y=D in Farbe C ausgeben,
               ;                    transparent
               ; GRAPH_TextOutTS    8x8 Zeichen ab (HL), Ende mit 0, Pos. DE Farbe C
               ;                    transparent
               ; GRAPH_WriteCharS   8x8 Zeichen A an Pos. x=E y=D in Farbe C ausgeben,
               ;                    Hintergrudf. in B
               ; GRAPH_TextOutS     8x8 Zeichen ab (HL), Ende mit 0, Pos. DE Farbe C
               ;                    Hintergrudf. in B
               ; GRAPH_WriteCharTB  12x16 Zeichen A an Pos. x=E y=D in Farbe C ausgeben,
               ;                    transparent
               ; GRAPH_TextOutTB    12x16 Zeichen ab (HL), Ende mit 0, Pos. DE Farbe C
               ;                    transparent
               ; GRAPH_HLine        Zeichnen einer Horizontalen Linie
               ;                    Start x=E End-x=B y=D Farbe=C
               ; GRAPH_VLine        Zeichnen einer Vertikalen Linie
               ;                    x=E Start-y=D End-y=B Farbe=C
               ; GRAPH_Rectangle    Zeichnet ein Rechteck
               ;                    E=x1, L=x2, D=y1, H=y2, C=Farbe
 
               ; GRAPH_SelViewPage  Angezeigte Bildseite whlen A=0..1
               ; GRAPH_SelDrawPage  Bildseite fr Zeichenop. whlen A=0..1
               ; GRAPH_POST         klar
 
               ; Makros
               ; SetColor Farbe,R,G,B
 
               ; Bildschrimauflsung ist 184*220 real
               ; und 184*256 dargestellt
 
 
GRAPH_Init:    ; CRTC RESET
               LD    A,0
               OUT   (VideoConfig),A
               LD    A,00010000b
               OUT   (VideoConfig),A
               ; Modus einstellen
               CALL  GRAPH_SetHiRes
               ; DAC Initalisieren
               ; d.h. PRMR auf FFh
               LD    A,0FFh
               OUT   (DACReadMask),A
               ; Aktuelle Videoseite ist 0
               XOR   A
               LD    (mGRAPH_DPage),A
               LD    (mGRAPH_ViewPage),A
               ; Bildspeicher aktuelle Seite lschen
               CALL  GRAPH_CLS
               ; Farbe0=Schwarz
               LD    A,0
               LD    HL,0
               LD    D,0
               CALL  GRAPH_SetColor
               ; dat war es
               RET
 
 
GRAPH_SetHiRes:; hohe Auflsung einstellen
               LD    A,00010000b
               LD    (mGRAPH_VideoMode),A
               OUT   (VideoConfig),A
               ; CRTC Initalisieren
               LD    HL,GRAPH_CRTCInitTabHiRes
               LD    B,GRAPH_CRTCInitTabLen
               LD    D,0
               LD    C,CRTCAdr
GRAPH_SH2:     OUT   (C),D
               LD    A,(HL)
               OUT   (CRTCData),A
               INC   HL
               INC   D
               DJNZ  GRAPH_SH2
               RET
GRAPH_CRTCInitTabHiRes: ; Tabelle fr CRTC_Startwerte bei HiRes
               DEFB  31 ; Horizontal Total
               DEFB  23 ; Horizontal Displayed
               DEFB  26 ; H Sync Pos
               DEFB  1  ; H Sync Width
               DEFB  38 ; Vertical Total
               DEFB  20 ; V. Total Adjust
               DEFB  32 ; Vertical Displayed
               DEFB  37 ; V. Sync Position
               DEFB  0  ; Interlace Mode
               DEFB  7 ; Max Scan Line Adr
               DEFB  32+64 ; Cursor Start Scan Line
               DEFB  7 ; Cursor End Scan Line
               DEFB  0 ; Start Adr (H)
               DEFB  0 ; Start Adr (L)
               DEFB  0 ; Cursor (H)
               DEFB  0 ; Cursor (L)
GRAPH_CRTCInitTabLen: EQU 16
 
GRAPH_SetColor:; Schreibt Farbe in RAMDAC
               ; Farbnr in A
               ; R in H
               ; G in L
               ; B in D
               OUT   (DACColorAdr),A
               LD    C,DACColor
               OUT   (C),H
               OUT   (C),L
               OUT   (C),D
               RET
 
               ; Makro zu Farbwahl
MACRO          SetColor,4
               LD    A,@1
               LD    H,@2
               LD    L,@3
               LD    D,@4
               CALL  GRAPH_SetColor
ENDMACRO
 
GRAPH_CLS:     ; CLS mit Farbe 0
               XOR   A
GRAPH_CLS_Color:; Aktuelle Bildseite lschen
               ; d.h. mit Farbe A fllen
               LD    D,A
               LD    A,(mGRAPH_DPage)
               LD    B,A
               LD    A,(mGRAPH_VideoMode)
               AND   11110000b
               OR    01000000b
               OR    B
               LD    (mGRAPH_VideoMode),A
               LD    C,0 ; Rasterzeilen-Nr
GRAPH_CLS_L1:  LD    A,(mGRAPH_VideoMode)
               AND   11110001b
               OR    C
               LD    (mGRAPH_VideoMode),A
               OUT   (VideoConfig),A
               INC   C
               INC   C
               LD    HL,0C000h
GRAPH_CLS_L1b: LD    E,32
GRAPH_CLS_L2:  LD    B,0  ; 8k=256*32
GRAPH_CLS_L3:  LD    (HL),D
               INC   HL
               DJNZ  GRAPH_CLS_L3
               DEC   E
               JR    NZ,GRAPH_CLS_L2
               LD    A,C
               AND   10000b
               JR    Z,GRAPH_CLS_L1
               LD    A,(mGRAPH_VideoMode)
               AND   10111111b
               OUT   (VideoConfig),A
               LD    (mGRAPH_VideoMode),A
               RET
 
GRAPH_GetLineReplacement:
               ; berechnet fr die logische Rasterzeile in A die physikalische
               PUSH  HL
               PUSH  DE
               LD    HL,GRAPH_LineReplacementTable
               LD    E,A
               LD    D,0
               ADD   HL,DE
               LD    A,(HL)
               POP   DE
               POP   HL
               RET
 
GRAPH_SetPixel:; Bildpunkt an Stelle x=E y=D Farbe=C setzen
               ; Rasterzeile ausrechnen
               LD    A,E
               CP    184
               RET   NC
               LD    A,D
               CP    220
               RET   NC
               CALL  GRAPH_GetLineReplacement
               LD    D,A
               AND   111b
               SLA   A
               LD    B,A
               LD    A,(mGRAPH_DPage)
               OR    B
               LD    B,A
               LD    A,(mGRAPH_VideoMode)
               AND   11110000b
               OR    B
               OR    01000000b
               LD    B,A
               ; Videoseitenkonf ist in B
               LD    A,D
               AND   11111000b
               LD    D,A
               LD    A,E
               LD    E,23
               CALL  MATH_MUL8
               ; in HL jetzt Zeilenoffset
               LD    E,A
               LD    D,0
               ADD   HL,DE
               LD    DE,0C000h
               ADD   HL,DE
GRAPH_SP2:     ; warten bis erlaubt
               CALL  GRAPH_WaitBlanking
               LD    A,B
               OUT   (VideoConfig),A
               LD    (HL),C
               LD    A,(mGRAPH_VideoMode)
               OUT   (VideoConfig),A
               EI
               RET
GRAPH_FastSetPixel:; Bildpunkt an Stelle x=E y=D Farbe=C setzen
                   ; Achtung mit Schnee!!
               ; Rasterzeile ausrechnen
               LD    A,D
               CALL  GRAPH_GetLineReplacement
               LD    D,A
               AND   111b
               SLA   A
               LD    B,A
               LD    A,(mGRAPH_DPage)
               OR    B
               LD    B,A
               LD    A,(mGRAPH_VideoMode)
               AND   11110000b
               OR    B
               OR    01000000b
               LD    B,A
               ; Videoseitenkonf ist in B
               LD    A,D
               AND   11111000b
               LD    D,A
               LD    A,E
               LD    E,23
               CALL  MATH_MUL8
               ; in HL jetzt Zeilenoffset
               LD    E,A
               LD    D,0
               ADD   HL,DE
               LD    DE,0C000h
               ADD   HL,DE
GRAPH_FSP2:    ; warten bis erlaubt
               LD    A,B
               OUT   (VideoConfig),A
               LD    (HL),C
               LD    A,(mGRAPH_VideoMode)
               OUT   (VideoConfig),A
               RET
 
GRAPH_WriteCharTS: ; Schreibt Zeichen in A an Pos x=E y=D in Farbe C
               ; Zeichensatz 8x8Pixel, transparent
               ; Fontdaten berechnen
               PUSH  IY
               SUB   A,32
               LD    L,A
               LD    H,0
               SLA   L
               RL    H
               SLA   L
               RL    H
               SLA   L
               RL    H
               PUSH  DE
               LD    DE,GRAPH_Font8x8
               ADD   HL,DE
               PUSH  HL
               POP   IY
               ; ab IY liegen die Fontdaten vor
               ; jetzt 16 Zeilen ausgeben
               ; in C Farbe
               POP   DE
               ; in DE Koordinaten
               LD    B,16 ; 8 Zeilen
GRAPH_WCTS2:   ; Zeilenadresse berechnen
               PUSH  BC
               PUSH  DE
               LD    A,D
               CALL  GRAPH_GetLineReplacement
               ; phys. Zeile in A
               PUSH  DE
               LD    B,A
               AND   11111000b
               LD    D,A
               LD    E,23
               CALL  MATH_MUL8
               POP   DE
               LD    D,0C0h
               ADD   HL,DE
               ; Speicheradresse in HL
               ; jetzt Rasterzeilen-Maske berechnen
               LD    A,B
               AND   111b
               SLA   A
               LD    B,A
               LD    A,(mGRAPH_DPage)
               OR    B
               LD    B,A
               LD    A,(mGRAPH_VideoMode)
               AND   11110000b
               OR    B
               OR    01000000b
               LD    E,A
               ; Video-Page-Register in E
               LD    B,8 ; 8 Pixel breit
               LD    D,(IY)
GRAPH_WCTS3:   SLA   D
               JR    NC,GRAPH_WCTS4 ; Pixel nicht setzen
               ; Pixel Setzen
               CALL  GRAPH_WaitBlanking
               LD    A,E
               OUT   (VideoConfig),A
               LD    (HL),C
               LD    A,(mGRAPH_VideoMode)
               OUT   (VideoConfig),A
               EI
GRAPH_WCTS4:   ; weiter
               INC   HL
               DJNZ  GRAPH_WCTS3
               POP   DE
               INC   D
               POP   BC
               LD    A,B
               AND   1
               JR    Z,GRAPH_WCTS5
               INC   IY
GRAPH_WCTS5:   DJNZ  GRAPH_WCTS2
               POP   IY
               RET
 
GRAPH_WriteCharS: ; Schreibt Zeichen in A an Pos x=E y=D in Farbe C
               ; Zeichensatz 8x8Pixel, Hintergrund in B
               ; Fontdaten berechnen
               PUSH  IY
               SUB   A,32
               LD    L,A
               LD    H,0
               SLA   L
               RL    H
               SLA   L
               RL    H
               SLA   L
               RL    H
               PUSH  DE
               LD    DE,GRAPH_Font8x8
               ADD   HL,DE
               PUSH  HL
               POP   IY
               ; ab IY liegen die Fontdaten vor
               ; jetzt 16 Zeilen ausgeben
               ; in C Farbe, in B Hintergrund
               LD    A,B
               LD    (mGRAPH_WCtmp),A
               POP   DE
               ; in DE Koordinaten
               LD    B,16 ; 8 Zeilen
GRAPH_WCS2:    ; Zeilenadresse berechnen
               PUSH  BC
               PUSH  DE
               LD    A,D
               CALL  GRAPH_GetLineReplacement
               ; phys. Zeile in A
               PUSH  DE
               LD    B,A
               AND   11111000b
               LD    D,A
               LD    E,23
               CALL  MATH_MUL8
               POP   DE
               LD    D,0C0h
               ADD   HL,DE
               ; Speicheradresse in HL
               ; jetzt Rasterzeilen-Maske berechnen
               LD    A,B
               AND   111b
               SLA   A
               LD    B,A
               LD    A,(mGRAPH_DPage)
               OR    B
               LD    B,A
               LD    A,(mGRAPH_VideoMode)
               AND   11110000b
               OR    B
               OR    01000000b
               LD    E,A
               ; Video-Page-Register in E
               LD    B,8 ; 8 Pixel breit
               LD    D,(IY)
GRAPH_WCS3:    SLA   D
               JR    NC,GRAPH_WCS4  ; Pixel nicht setzen
               ; Pixel Setzen
               CALL  GRAPH_WaitBlanking
               LD    A,E
               OUT   (VideoConfig),A
               LD    (HL),C
               LD    A,(mGRAPH_VideoMode)
               OUT   (VideoConfig),A
               EI
               JR    GRAPH_WCS4b
GRAPH_WCS4:    CALL  GRAPH_WaitBlanking
               LD    A,E
               OUT   (VideoConfig),A
               LD    A,(mGRAPH_WCtmp)
               LD    (HL),A
               LD    A,(mGRAPH_VideoMode)
               OUT   (VideoConfig),A
               EI
GRAPH_WCS4b:    ; weiter
               INC   HL
               DJNZ  GRAPH_WCS3
               POP   DE
               INC   D
               POP   BC
               LD    A,B
               AND   1
               JR    Z,GRAPH_WCS5
               INC   IY
GRAPH_WCS5:    DJNZ  GRAPH_WCS2
               POP   IY
               RET
 
GRAPH_TextOutTS:; Zeichensatz 8x8 Pixel
               ; Textausgabe, x=E y=D Farbe=C, Text ab HL,
               ; Ende mit 0
               LD    A,(HL)
               OR    A
               RET   Z
               INC   HL
               PUSH  HL
               PUSH  DE
               PUSH  BC
               CALL  GRAPH_WriteCharTS
               POP   BC
               POP   DE
               POP   HL
               LD    A,E
               ADD   A,8
               LD    E,A
               JR    GRAPH_TextOutTS
 
GRAPH_WriteCharTB: ; Schreibt Zeichen in A an Pos x=E y=D in Farbe C
               ; Zeichensatz 12x16 Pixel, transparent
               ; erstmal via SetPixel, langsam und bequem
               ; Fontdatenadresse berechnen
               SUB   A,32
               LD    L,A
               LD    H,0
               SLA   L
               RL    H
               SLA   L
               RL    H
               SLA   L
               RL    H
               SLA   L
               RL    H
               SLA   L
               RL    H
               PUSH  DE
               LD    DE,GRAPH_Font12x16
               ADD   HL,DE
               POP   DE
               ; Font-Adr. in HL
               LD    B,32 ;16*2 Zeilen
GRAPH_WCTB1:   LD    A,(HL)
               PUSH  DE
               PUSH  HL
               LD    L,8 ; 8 Spalten
GRAPH_WCTB2:   PUSH  BC
               PUSH  DE
               RLA
               PUSH  AF
               PUSH  HL
               CALL  C,GRAPH_SetPixel
               POP   HL
               POP   AF
               POP   DE
               POP   BC
               INC   E ; x=x+1
               DEC   L
               JR    NZ,GRAPH_WCTB2
               POP   HL
               INC   HL
               LD    A,(HL)
               PUSH  HL
               LD    L,4 ; 4 weitere Spalten
GRAPH_WCTB3:   PUSH  BC
               PUSH  DE
               RLA
               PUSH  AF
               PUSH  HL
               CALL  C,GRAPH_SetPixel
               POP   HL
               POP   AF
               POP   DE
               POP   BC
               INC   E ; x=x+1
               DEC   L
               JR    NZ,GRAPH_WCTB3
               POP   HL
               POP   DE
               INC   D
               LD    A,B
               AND   1
               JR    NZ,GRAPH_WCTB4 ; ungerade =>HL +1
               DEC   HL
               DJNZ  GRAPH_WCTB1
               RET
GRAPH_WCTB4:   INC   HL
               DJNZ  GRAPH_WCTB1
               RET
 
GRAPH_TextOutTB:; Zeichensatz 12x16 Pixel
               ; Textausgabe, x=E y=D Farbe=C, Text ab HL,
               ; Ende mit 0
               LD    A,(HL)
               OR    A
               RET   Z
               INC   HL
               PUSH  HL
               PUSH  DE
               PUSH  BC
               CALL  GRAPH_WriteCharTB
               POP   BC
               POP   DE
               POP   HL
               LD    A,E
               ADD   A,12
               LD    E,A
               JR    GRAPH_TextOutTB
 
GRAPH_HLine:   ; Zeichnen einer Horizontalen Linie
               ; Start x=E End-x=B y=D Farbe=C
               ; Rasterzeile ausrechnen
               ; Pixelzahl berechnen
               ; Rasterzeile korrigieren
               LD    A,B
               SUB   E
               INC   A
               LD    B,A
               PUSH  BC
               LD    A,D
               CALL  GRAPH_GetLineReplacement
               LD    D,A
               AND   111b
               SLA   A
               LD    B,A
               LD    A,(mGRAPH_DPage)
               OR    B
               LD    B,A
               LD    A,(mGRAPH_VideoMode)
               AND   11110000b
               OR    B
               OR    01000000b
               LD    B,A
               ; Videoseitenkonf ist in B
               LD    H,0C0h
               LD    L,E
               PUSH  HL
               LD    A,D
               AND   11111000b
               LD    D,A
               LD    A,E
               LD    E,23
               CALL  MATH_MUL8
               ; in HL jetzt Zeilenoffset
               POP   DE
               ADD   HL,DE ;in HL Zieladr
               LD    D,B ; in D Seitenkonf.
               POP   BC
               ; B= Pixelanzahl, C=Farbe
               LD    A,(mGRAPH_VideoMode)
               LD    E,A
GRAPH_HL2:     ; warten bis erlaubt
               CALL  GRAPH_WaitBlanking
               LD    A,D
               OUT   (VideoConfig),A
               LD    (HL),C
               LD    A,E
               OUT   (VideoConfig),A
               EI
               INC   HL
               DJNZ  GRAPH_HL2
               RET
 
GRAPH_VLine:   ; Zeichnen einer Vertikalen Linie
               ; x=E Start-y=D End-y=B Farbe=C
               ; Pixelzahl berechnen
               LD    A,D
               CALL  GRAPH_GetLineReplacement
               LD    D,A
               LD    A,B
               CALL  GRAPH_GetLineReplacement
               SUB   A,D
               INC   A
               LD    B,A
               PUSH  BC
               ; so, auf Stack Phys Zeilenzahl+Farbe
               ; Start-Rasterzeile ausrechnen
               LD    H,0C0h
               LD    A,D
               AND   111b
               SLA   A
               LD    B,A
               LD    A,(mGRAPH_DPage)
               OR    B
               LD    B,A
               LD    A,(mGRAPH_VideoMode)
               AND   11110000b
               OR    B
               OR    01000000b
               LD    B,A
               ; Videoseitenkonf fr 1.Zeile ist in B
               LD    L,E
               PUSH  HL
               LD    A,D
               AND   11111000b
               LD    D,A
               LD    A,E
               LD    E,23
               CALL  MATH_MUL8
               ; in HL jetzt Zeilenoffset
               POP   DE
               ADD   HL,DE ;in HL Zieladr
               LD    D,B ; in D Seitenkonf.
               POP   BC
               ; B= Pixelanzahl, C=Farbe
               LD    A,(mGRAPH_VideoMode)
               LD    E,A
GRAPH_VL2:     ; warten bis erlaubt
               CALL  GRAPH_WaitBlanking
               LD    A,D
               OUT   (VideoConfig),A
               LD    (HL),C
               LD    A,E
               OUT   (VideoConfig),A
               EI
               ; so, nu eine Zeile weiter
               LD    A,D
               ADD   A,2
               LD    D,A
               AND   1110b
               JR    Z,GRAPH_VL3 ; Rasterzeilen-bertrag
               DJNZ  GRAPH_VL2
               RET
GRAPH_VL3:     LD    A,D
               SUB   A,16
               LD    D,A
               PUSH  DE
               LD    DE,184
               ADD   HL,DE
               POP   DE   ; neue Zeilenadresse in HL
               DJNZ  GRAPH_VL2
               RET
 
GRAPH_Rectangle: ; Zeichnet ein Rechteck
               ; E=x1, L=x2, D=y1, H=y2, C=Farbe
               LD    A,H
               SUB   A,D
               INC   A
               LD    H,A ; Anzahl zeilen
               LD    B,L
GRAPH_RT2:     PUSH  DE
               PUSH  BC
               PUSH  HL
               CALL  GRAPH_HLine
               POP   HL
               POP   BC
               POP   DE
               INC   D
               DEC   H
               JR    NZ,GRAPH_RT2
               RET
 
GRAPH_SelViewPage:
               ; Auswahl der angezeigen Bildseite in A=0..1
               AND   1
               LD    (mGRAPH_ViewPage),A
               SLA   A
               SLA   A
               LD    B,A
               LD    A,12
               OUT   (CRTCAdr),A
               LD    A,B
               OUT   (CRTCData),A
               RET
GRAPH_SelDrawPage:
               ; Auswahl der Bildseite fr Zeichenoperationen
               AND   1
               LD    (mGRAPH_DPage),A
               RET
 
GRAPH_WaitBlanking: ; warten auf Blanking-Beginn
               EI
               NOP
               DI
               IN    A,(PioB)
               RLA
               JR    C,GRAPH_WaitBlanking
GRAPH_WaitBLK2:EI
               NOP
               DI
               IN    A,(PioB)
               RLA
               JR    NC,GRAPH_WaitBLK2
               RET

; Testroutine, erwartet an serieller Schnittstelle 
; je 3 Farbbytes fr die Farben 16..254, dann je ein Byte fr jedes
; der 184x220 Bildpixel

GRAPH_ReceiveBackground:
               LD    A,16
GRAPH_RxB1:    PUSH  AF
               CALL  SIO_ReadSync
               LD    H,A
               PUSH  HL
               CALL  SIO_ReadSync
               POP   HL
               LD    L,A
               PUSH  HL
               CALL  SIO_ReadSync
               POP   HL
               LD    D,A
               POP   AF
               PUSH  AF
               CALL  GRAPH_SetColor
               POP   AF
               INC   A
               CP    255
               JR    NZ,Graph_RxB1
               ; Palette empfangen, jetzt das Bild
               LD    D,0
Graph_RxB2:    LD    E,0
Graph_rxB3:    PUSH  DE
               CALL  SIO_ReadSync
               POP   DE
               LD    C,A
               PUSH  DE
               CALL  GRAPH_SetPixel
               POP   DE
               INC   E
               LD    A,E
               CP    184
               JR    NZ,Graph_RxB3
               INC   D
               LD    A,D
               CP    220
               JR    NZ,Graph_RxB2
               RET
 
GRAPH_POST:    ; Selbsttest
               ; Messung der Blanking-Rate
               LD    HL,GRAPH_PT1
               CALL  TXT_Write
               LD    HL,100
               LD    (mTIMER_Delay),HL
               LD    HL,0
GRAPH_POST2:   LD    A,(mTIMER_Delay)
               OR    A
               JR    Z,GRAPH_POST4
               IN    A,(PioB)
               RLA
               JR    NC,GRAPH_POST2
               INC   HL
GRAPH_POST3:   LD    A,(mTIMER_Delay)
               OR    A
               JR    Z,GRAPH_POST4
               IN    A,(PioB)
               RLA
               JR    C,GRAPH_POST3
               JR    GRAPH_POST2
GRAPH_POST4:   ; in HL sollte nun Wert um 12800 stehen
               ; d.h. zw 10000 und 15000
               ; d.h. in H zw. 39 und 59
               LD    A,H
               CP    39
               JR    C,GRAPH_POSTFail
               CP    60
               JR    NC,GRAPH_PostFail
               ; POST bestanden
               LD    HL,GRAPH_PT2
GRAPH_PostExit:CALL  TXT_Write
               LD    HL,20
               JP    TIMER_DELAY
GRAPH_PostFail:LD    HL,GRAPH_PT3
               JR    GRAPH_POSTExit
GRAPH_PT1:     DEFB  1
               DEFM  "Video/CRTC:     "
               DEFB  0
GRAPH_PT2:     DEFB  4
               DEFM  "passed"
               DEFB  13,10,0
GRAPH_PT3:     DEFB  2
               DEFM  "failed"
               DEFB  13,10,0
 
GRAPH_LineReplacementTable:
               ; Tabelle ber die verschiedenen Zeilennummern
               ; 220 Bytes; jeder Eintrag enthlt die Tatschliche
               ; Rasterzeile fr die jeweilige logische...
               DEFB  0,1,2,3,5,6,7,8,9,10,11
               DEFB  13,14,15,16,17,19,20,21,22,23,24,25
               DEFB  27,28,29,30,31,33,34,35,36,37,38,39
               DEFB  41,42,43,44,45,47,48,49,50,51,52,53
               DEFB  55,56,57,58,59,61,62,63,64,65,66,67
               DEFB  69,70,71,72,73,75,76,77,78,79,80,81
               DEFB  83,84,85,86,87,89,90,91,92,93,94,95
               DEFB  97,98,99,100,101,103,104,105,106,107,108,109
               DEFB  111,112,113,114,115,117,118,119,120,121,122,123
               DEFB  125,126,127,128,129,131,132,133,134,135,136,137
               DEFB  139,140,141,142,143,145,146,147,148,149,150,151
               DEFB  153,154,155,156,157,159,160,161,162,163,164,165
               DEFB  167,168,169,170,171,173,174,175,176,177,178,179
               DEFB  181,182,183,184,185,187,188,189,190,191,192,193
               DEFB  195,196,197,198,199,201,202,203,204,205,206,207
               DEFB  209,210,211,212,213,215,216,217,218,219,220,221
               DEFB  223,224,225,226,227,229,230,231,232,233,234,235
               DEFB  237,238,239,240,241,243,244,245,246,247,248,249
               DEFB  251,252,253,254,255
 
 
 
               include "bigfont.asm" ; Schriften
               include "thinfont.asm"
 
 
