               ; Car Booster v2
               ; Betriebsprogramm
               ; v0.01 22.1.99
               ; (c) Tassilo Heeg 1999
               ; Text-Modul fr 8x8 Zeichensatz
               ; Cursor-Steuerung
 
 
TXT_Init:      ; Initalisierungen
               LD    A,1
               ; Cursor Home
               LD    (mTXT_CursorX),A
               LD    (mTXT_CursorY),A
               LD    (mTXT_FGColor),A
               XOR   A
               LD    (mTXT_BGColor),A
               LD    (mTXT_DrawMode),A
 
               RET
 
TXT_GotoXY:    ; Cursor auf x=E, y=D
               ; x=1..23, y=1..13
               LD    (mTXT_Cursor),DE
TXT_PlaceCursor:;Hardware-Cursor positionieren
               LD    DE,(mTXT_Cursor)
               DEC   E
               LD    B,E
               LD    E,17 ; jede Zeichenbox ist 17 logische Zeilen hoch
               CALL  MATH_MUL8
               DEC   L
               DEC   L
               ; in L haben wir jetzt die logische Rasterzeile,
               ; in der Cursor beginnen soll
               LD    A,L
               CALL  GRAPH_GetLineReplacement
               LD    L,A
TXT_PlaceC2:   LD    C,L
               LD    D,L
               SRL   D
               SRL   D
               SRL   D
               LD    E,23
               CALL  MATH_MUL8
               LD    E,B
               LD    D,0
               ADD   HL,DE
               ; in HL jetzt Cursor-Adresse
               LD    A,(mGRAPH_ViewPage)
               SLA   A
               OR    H
               LD    H,A
               LD    A,14
               OUT   (CRTCAdr),A
               LD    A,H
               OUT   (CRTCData),A
               LD    A,15
               OUT   (CRTCAdr),A
               LD    A,L
               OUT   (CRTCData),A
               ; Positioniert isser
               ; Start+End-Rasterzeile
               LD    A,10
               OUT   (CRTCAdr),A
               LD    A,C
               AND   111b
               LD    C,A
               LD    A,(mTXT_CursorMode)
               OR    C
               OUT   (CRTCData),A
               INC   C
               INC   C
               LD    A,11
               OUT   (CRTCAdr),A
               LD    A,C
               OUT   (CRTCData),A
               RET
 
TXT_SetFGColor:;Vordergrundfarbe einstellen
               LD    (mTXT_FGColor),A
               RET
TXT_SetBGColor:;Hintergrundfarbe einstellen
               LD    (mTXT_BGColor),A
               RET
TXT_SetDrawMode:; 0: Transparent 1: mit HG
               LD    (mTXT_DrawMode),A
               RET
 
TXT_WriteChar: ; Zeichen in A ausgeben
               ; Steuercodes auswerten
               CP    32
               JR    C,TXT_WriteCtrl
               LD    DE,(mTXT_Cursor)
               PUSH  DE
               DEC   E
               DEC   D
               SLA   E
               SLA   E
               SLA   E
               ; E ist OK
               LD    C,E
               LD    E,17
               CALL  MATH_MUL8
               LD    D,L
               LD    E,C
               LD    L,A
               ; Grafik-Position in DE
               LD    BC,(mTXT_FGColor)
               LD    A,(mTXT_BGColor)
               LD    B,A
               LD    A,(mTXT_DrawMode)
               OR    A
               LD    A,L
               JR    NZ,TXT_WriteCharOP
               ; transparent
               CALL  GRAPH_WriteCharTS
               JR    TXT_WriteChar2
TXT_WriteCharOP:; opaque
               CALL  GRAPH_WriteCharS
TXT_WriteChar2:POP   DE
               INC   E
               LD    A,E
               CP    24
               JR    NZ,TXT_WriteChar3
               LD    E,1
               INC   D
               LD    A,D
               CP    14
               JR    NZ,TXT_WriteChar3
               LD    D,1
TXT_WriteChar3:JP    TXT_GotoXY ; Cursor neu positionieren
TXT_WriteCTRL: ; Dies war ein Steuerzeichen
               ; #01..#09: Setzt Textfarbe auf 1..9
               ; #10: LF
               ; #13: CR
               ; #12: FF = CLS
               OR    A
               RET   Z ; NUL ignorieren
               CP    10
               JR    C,TXT_SetFGColor
               JR    Z,TXT_WriteLF
               CP    13
               JR    Z,TXT_WriteCR
               CP    12
               JR    Z,TXT_WriteFF
               ; unbekannt
               RET
TXT_WriteLF:   LD    DE,(mTXT_Cursor)
               INC   D
               LD    A,D
               CP    14
               JP    NZ,TXT_GotoXY
               LD    D,1
               JP    TXT_GotoXY
TXT_WriteCR:   LD    DE,(mTXT_Cursor)
               LD    E,1
               JP    TXT_GotoXY
TXT_WriteFF:   LD    A,(mTXT_BGColor)
               CALL  GRAPH_CLS_Color
               LD    DE,256+1
               JP    TXT_GotoXY
 
TXT_Write:     ; Textausgabe an aktueller Pos., (HL), bis 0
               LD    A,(HL)
               OR    A
               RET   Z
               INC   HL
               PUSH  HL
               CALL  TXT_WriteChar
               POP   HL
               JR    TXT_Write
 
TXT_CursorMode:; Cursor Mode 0..3 in A
               ; 0: Aus
               ; 1: Ein
               ; 2: Schnell blinken
               ; 3: langsam blinken
               XOR   1
               AND   3
               RRCA
               RRCA
               RRCA
               LD    (mTXT_CursorMode),A
               JP    TXT_PlaceCursor
 
 
 
 
